#include "Histogram.h"
#include <iostream>
#include <iomanip>
#include <cmath>

Histogram::Histogram(int bins, double xmin, double xmax) :
  _bins(bins), _xmin(xmin), _xmax(xmax) {
    _entries = new double[bins];
    for(int i = 0; i < bins; ++i)
      _entries[i] = 0;
  }

Histogram::~Histogram() {
  delete [] _entries;
}

void Histogram::fill(double x) {
  int bin = (x - _xmin)/(_xmax - _xmin) * _bins;
  if(bin < 0 || bin >= _bins) return;
  _entries[bin]++;
}

void Histogram::print() const {
  double dx = (_xmax - _xmin)/_bins;
  for(int i = 0; i < _bins; i++) {
    double x1 = i * dx;
    double x2 = x1 + dx;
    std::cout << "[" << std::fixed << std::setw(5) << std::setprecision(4)
	      << x1 << ", " << std::setw(5) << std::setprecision(4) << x2 << "] ";
    for(int j = 0; j < _entries[i]; j++)
      std::cout << "=";
    std::cout << " (" << std::setw(5) << std::setprecision(4) << _entries[i] << ")\n";
  }
}
